"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const mz_1 = require("mz");
const npa = require("npm-package-arg");
const path = require("path");
const shelljs = require("shelljs");
function installDependencies(dependency, packagePath) {
    return new Promise((resolve, reject) => {
        const depString = `${dependency.name}@${dependency.version}`;
        const spec = npa(depString);
        let nodePath = dependency.nodePath;
        if (!nodePath || !mz_1.fs.statSync(nodePath)) {
            nodePath = path.resolve(__dirname, '../../../node_modules');
            if (!mz_1.fs.statSync(nodePath)) {
                debugger;
                reject('node_modules folder is not found!');
            }
        }
        const run = shelljs.exec(`mkdir -p ${packagePath} && cd ${packagePath} && HOME=/tmp node ${path.join(nodePath, "yarn", "lib", "cli")} add ${depString} ${spec.type === "git" ? "" : "--ignore-scripts"} --no-lockfile --non-interactive --no-bin-links --ignore-engines --skip-integrity-check --cache-folder ./ --registry=http://registry.m.jd.com`);
        if (run.code !== 0) {
            reject(run.stdout);
        }
        else {
            const pattr = new RegExp(`${dependency.name.replace('/', '\/')}@(.*)`);
            const match = run.stdout.match(pattr);
            resolve(match && match[1]);
        }
    });
}
exports.default = installDependencies;
//# sourceMappingURL=install-dependencies.js.map