"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// @ts-ignore
const acorn_walk_1 = require("acorn-walk");
const meriyah = require("meriyah");
function exportRequires(code) {
    let ast;
    let isModule = false;
    try {
        ast = meriyah.parseScript(code);
    }
    catch (e) {
        isModule = true;
        ast = meriyah.parseModule(code);
    }
    const requires = [];
    acorn_walk_1.default.simple(ast, {
        ImportDeclaration(node) {
            isModule = true;
            // Seems like the typings are wrong in the library
            const source = node.source;
            if (source && typeof source.value === "string") {
                requires.push(source.value);
            }
        },
        ImportExpression(node) {
            isModule = true;
            // Seems like the typings are wrong in the library
            const source = node.source;
            if (source && typeof source.value === "string") {
                requires.push(source.value);
            }
        },
        ExportNamedDeclaration(node) {
            isModule = true;
            const source = node.source;
            if (source && typeof source.value === "string") {
                requires.push(source.value);
            }
        },
        ExportAllDeclaration(node) {
            isModule = true;
            const source = node.source;
            if (source && typeof source.value === "string") {
                requires.push(source.value);
            }
        },
        CallExpression(node) {
            if (
            /* require() */ (node.callee.type === "Identifier" &&
                node.callee.name === "require") ||
                node.callee.type === "Import" ||
                /* require.resolve */ (node.callee.type === "MemberExpression" &&
                    node.callee.object.name &&
                    node.callee.object.name === "require" &&
                    node.callee.property.name &&
                    node.callee.property.name === "resolve")) {
                if (node.arguments.length === 1) {
                    if (node.arguments[0].type === "Literal") {
                        const { value } = node.arguments[0];
                        if (typeof value === "string") {
                            requires.push(value);
                        }
                    }
                    else if (node.arguments[0].type === "TemplateLiteral") {
                        const { quasis } = node.arguments[0];
                        if (quasis.length === 1) {
                            requires.push(quasis[0].value.raw);
                        }
                    }
                }
            }
        },
    });
    return { requires, isModule };
}
exports.default = exportRequires;
//# sourceMappingURL=extract-requires.js.map